<?php

/* astrosort-pagetext.php
Used by astrosortfilegen.php to create the display and output versions of astrosort lists and musician lists. */

function GetPageHeader ($title)
{
	$res = "<html><head><TITLE>Astroblahhh.Com - $title</TITLE>

<link rel=stylesheet href=\"../../css/a.css\" type=\"text/css\">

<style type=\"text/css\">";

	return $res;

}


function GetCss($type)
{	
	if ($type=="sort")
	{	
		
		$res="li
{ 
	padding-bottom: 10px;
	margin:3%;

}

ol
{	margin:3%;
	padding:0px;
}

.l
{	font-size: smaller;
}

.v, .w
{	word-spacing: 5px;
	font-weight: bold;
}

.v 
{	color: lime;
}

.n
{	color: darkorange;
	font-size: larger;
}

.w
{
	color: red;
}

table, tr, td, th
{
	border-style: ridge;
	border-color: darksalmon;
	border-width: 1px;
}

th, td, tr
{	background-color: black;
}
th
{	color: darkorange;
}
td
{	color: orange;
}
	
h3
{	padding-top: 13px;
	margin: 3%;
}";

	}

	else if ($type=="sort2")
	{	

		$res="li
{ 
	padding-bottom: 10px;
	text-indent: 0;

}

ol
{	margin:3%;
	padding:0px;
}

.l
{	font-size: smaller;
}

.v, .w
{	word-spacing: 5px;
	font-weight: bold;
}

.v 
{	color: lime;
}

.n
{	color: darkorange;
	font-size: larger;
}

.w
{
	color: red;
}

a:link.ext, .navexts a:link, .exts a:link
{	color: khaki;
}

a:visited.ext, .navexts a:visited, .exts a:visited
{	color: goldenrod ;
}

a:hover.ext, .navexts a:hover, .exts a:hover
{	color: khaki;
}

a:link.int_anch, a:visited.int_anch, .navanchs a:link, .navanchs a:visited, .tbnav a:link, .tbnav a:visited, .toc a:link, .toc a:visited, .int_anchs a:link, .int_anchs a:visited
{	color: gold ;
	font-weight: bold;
}

a:hover.int_anch, .navanchs a:hover, .tbnav a:hover, .toc a:hover, .int_anchs a:hover
{	color: khaki;
}

table, tr, td, th
{
	border-style: ridge;
	border-color: gold ;
	border-width: 1px;
}

h3
{	padding-top: 13px;
}";

	}

	else if ($type=="musicians")
	{

		$res="li
{ 
	padding-bottom: 10px;
	text-indent: 0;

}

.navanchs
{	line-height: 1.25;
}


a:link.ext, .navexts a:link, .exts a:link
{	color: gold;
}

a:visited.ext, .navexts a:visited, .exts a:visited
{	color: goldenrod ;
}

a:hover.ext, .navexts a:hover, .exts a:hover
{	color: khaki;
}

a:link.int_anch, a:visited.int_anch, .navanchs a:link, .navanchs a:visited, .tbnav a:link, .tbnav a:visited, .toc a:link, .toc a:visited, .int_anchs a:link, .int_anchs a:visited
{	color: gold ;
	font-weight: bold;
}

a:hover.int_anch, .navanchs a:hover, .tbnav a:hover, .toc a:hover, .int_anchs a:hover
{	color: khaki;
}

table, tr, td, th
{
	border-style: outset;
	border-color: gold ;
	border-width: 1px;
}

	
h3
{	padding-top: 13px;
}";


}

	
	return $res;
}


function CloseCss()
{	
	$res="</style></head><BODY>";
	return $res;
}


function PrintNavLinks($deadlink)
{	global $multipage;

	$res = "<div class=\"navlinks\">";

	if ($deadlink!=0)
	{	
		$res .= "<a href=\"systemdesc.shtml\">";
	}

	$res .= "Astrosorting&nbsp;System&nbsp;Description</a> | ";

	if ($deadlink!=1)
	{	$res .= "<a href=\"";
		if ($multipage)
		{	$res .= "mercury.shtml\">";
		}
		else
		{	$res .= "musiclist.shtml\">";
		}
	}
	$res .= "Music&nbsp;List</a> | ";

	if ($deadlink!=2)
	{	$res .= "<a href=\"musicianlinks.shtml\">";
	}

	$res .= "Musician&nbsp;Links</a> | <a href=\"songupdatehistory.shtml\">Song&nbsp;Update&nbsp;History</a> | <a href=\"../../software/amodb/index.shtml\">AMODB</a></div>";

	return $res; 
}


function GetPageSubheader($deadlink)
{
	$res = "</style></head><BODY><p><br>
<!--#include virtual=\"../../ssi/h.html\" -->

<p><hr><div class=\"tbnav\"><a href=\"#bottom\">Go to bottom</a></div><p>";

	$res .= PrintNavLinks($deadlink);
	$res .= "<div id=\"maintext\">";

	return $res;
}

function GetMusiciansPageText()
{
	$res="<p><br>This page features musicians from the Astrosorted Music List, as well other musicians I like.  It is, however, very far from being a complete list.<p>";

	return $res;
}


function GetPageFooter($deadlink)
{	global $public;

	$lmdate=time();
	$lmdate=date("M. j, Y");
	$res="</ol></div>";

	if ($public)
	{	$res .= PrintNavLinks($deadlink);
	}

	$res .= "<p><br>
<a name=\"bottom\"></a>
<div class=\"tbnav\"><a href=\"#top\">Go to top</a></div>
<div id=\"lm\">Last modified: $lmdate<br>
This page uploaded to web: Apr. 4, 2008</div>
<hr>
<p>
<br>
<!--#include virtual=\"../../ssi/f.html\" -->
<p>
<br>
</body></html>";

	return $res;
}


function GetDesc()
{	global $numofsongs, $multipage;

	$res="<p><div class=\"navanchs\"><a href=\"#labels\">Labels</a> | <a href=\"#summaries\">Briefer Summaries</a></div><p><center><h2>\"Astrosorting\" system of music organization, inspired by astrology</a></h2></center>
<p>
<hr>
<p>
<ul><li><a href=\"http://astroblahhh.com/software/amodb/index.shtml\">The Astrosorting Music Organization Database (AMODB) software, written in PHP, MySQL and JavaScript</a>
<p>
<li><a href=\"";

	if ($multipage)
	{	$res .="mercury.shtml";
	}
	else
	{	$res .="musiclist.shtml";
	}

	$res .="\">List of $numofsongs songs sorted according to this system</a></ul>";

	$res .= "<p><hr><p>
I have a huge, very diverse music collection, which makes for some very jarring transitions in mood from one song to another if I just lump everything into one gigantic playlist.  This is, at times, annoying.
<p>
In addition to my interest in music, I also have an interest (though not belief) in astrology.  So, one day, I thought to myself, since the process of understanding astrology is so subjective, and so is the process of judging the overall mood of a piece of music - why not combine the two, and use the names of the planets as labels in a system of music organization?
<p>
The planets in astrology each correspond to their own distinct array of qualities/emotions/characteristics. There is basically little overlap between one planet's array of basic meanings and another's, and the breadth of these arrays is not nearly so limiting as a single adjective like \"happy\" or \"sad\", or even genre names like \"rock\" or \"classical\".
<p>
This, in my opinion, makes the planets' names very suitable as labels in a system of music organization - since I think one wouldn't want a system that's <i>too</i> rigid or narrow, or one might end up with playlists of music that all sounds much too alike to the point where it gets really boring.  Yet the labels aren't so broad that there isn't still a fair amount of clarity in the labels - so even if they aren't quite so limited as a single adjective, one can still have a pretty good basic idea of the overall range of possible sounds or moods.
<P>
In my system, each song gets anywhere from one to three main labels, usually three, to describe its overall type or mood.  There are very few songs that are so purely described by one label that I'll merely give it one and leave it at that - so, most songs receive at least a second label and most often a third.  The first label is the most important one, the second is a strong modifier of the first label, and the third, and any labels beyond that, add still more detail. 
<p>
At times, just three labels seems insufficient, so, often I also include one or more sublabels within parentheses after a song name.  An extra sublabel might indicate characteristics which are strong enough that the sublabel is practically just as significant as a main label - though, on the other hand, a sublabel might only indicate characteristics which are present only weakly, or from time to time, but not throughout the song.  In any case, though, I try to order the labels and sublabels roughly in decreasing order of importance.
<p>
<br>
<a name=\"eris\"></a>
In addition to the 8 main astrological planets other than the sun and moon, I also decided to include the dwarf planet Eris.  Discord doesn't usually have a major role in music - at least, not good music - but, sometimes it's there, and sometimes it doesn't ruin the song (or sometimes it makes the non-discordant parts sound better in contrast to the discordant stuff), so, there is a place for Eris in this system.
<p>
It is rare that a song with a lot of discord is really good, though, at least in my opinion, so I don't think there will ever end up being an entire section of Eris music here, since I only intend to list good music here (or, to be more precise, music which sounds good to me).  I also don't think I'm going to be using Eris as any one of the three main labels most of the time - usually only as an occasional sublabel.
<p>
Almost the only famous example of music I can think of which deserves to be labeled \"Eris\" as one of the main labels is Igor Stravinsky's <i>The Rite of Spring</i>.  That stuff is truly horrible, sounds like the kind of music which would be played in Hell.  Seems very Plutonian as well.  This is only a piece of it, but I'd label <a href=\"http://www.youtube.com/watch?v=Cvc8kZrNMtw\" class=ext>this monstrosity</a> Eris/Pluto/Saturn (Mars/Uranus/Venus).  Awful, awful, awful stuff.
<p>
(Though, as I keep listening to some other clips of other parts of <i>The Rite of Spring</i> on YouTube, I have to admit, it's interesting because it's so weird and unusual, and some of it almost does sort of grow on you a bit, or at least seems like it could be developed/remixed into something listenable - but I still can't say I really like it).
<p>
Also, though I haven't listened to all of it, it seems the <a href=\"http://www.youtube.com/watch?v=Tv67YkOWJNA\" class=ext>Turangalila Symphony</a> also is largely made up of annoying discord, but after listening to that bit of <i>The Rite of Spring</i> it's almost pleasant (and, the more I listen to it, the more bearable and strangely almost appealing it seems to get).  I guess I'd label that something more like Eris/Jupiter/Uranus (Venus/Pluto) or something... :-)
<p>
Darn, as of 4/4/2008, that video won't play for me correctly in the Opera web browser, though other browsers work.  I don't know if it's a problem just with my own computer or for Opera users in general, but, just in case any Opera users out there can't be bothered to open a different web browser to hear that, here's an alternative video, which unfortunately has poorer audio quality and annoying voiceovers: <a href=\"http://www.youtube.com/watch?v=vVtDR5BoyFM&feature=related\" class=ext>http://www.youtube.com/watch?v=vVtDR5BoyFM&feature=related</a>  
<p>
Anyhow, even though the Turangalila music is somehow growing on me, I don't really recommend either that or <i>The Rite of Spring</i> - in my opinion, they're overall rather disturbing, as well as potentially way more stress-inducing than the average bad or mediocre music (which generally isn't even deliberately designed to be annoying and yet is enough to stress me out and wreck my mood if I'm forced to listen to it).
<p>
<br>
<a name=\"labels\"></a>
Here are some ideas of what I tend to use the labels to mean (though only part of each label description tends to apply to any one song):
<p>
<b>Mercury:</b> intricate, clever, lots of string-plucking or key-pressing, very busy; not very emotional or deeply moving; lots of fast little notes.  Well-organized, with a more or less regular and recognizable pattern, though which is fluid and flexible, rather than rigid and repetitive.  Very clever, but may be lacking in true unpredictability, or a Uranian edge of \"where in the heck did that come from?\"  (For example, a lot of <a href=\"http://www.sankey.ws/scarlattirec.html\" class=ext>Domenico Scarlatti's songs</a> - they're all brilliant and dazzling, but once you hear one, it's like you've heard them all, since there's rarely anything truly unexpected in them or blow-you-away surprising that breaks free of the standard pattern of Scarlatti songs).  Playful, childish, not necessarily particularly dignified, lots of blips and boops...
<p>
<b>Venus:</b> pretty, pleasant, very nice and sweet, but not profound.  Lots of string ensembles, choir, harp, etc.; soft, smooth, relaxed, gentle.
<p>
<b>Mars:</b> energetic, warlike; a tendency toward being rhythmic; heavy drums; marching themes; hard, loud, gritty, low; electric guitar, etc.
<p>
<b>Jupiter:</b> cheerful, happy, buoyant, robust; loud, grand, unrestrained; glorious and free.  A Jupiter sub-label can indicate dark Saturn-labeled and Pluto-labeled music is lightened up a bit, or is more energetic, grand and loud than otherwise; it can also indicate that a piece of Neptune-labeled music is more light and positive rather than just spacy and mystical, etc.
<p>
<b>Saturn:</b> melancholic and dark; formal, possessing a dignified grandeur, restrained, controlled, mature; slow, steady, serious, somber, dignified; rhythmic, stable, predictable, everything kept firmly in line, like clockwork. Sometimes really sadly melancholy, but usually too controlled, unless mixed with something like Neptune; sometimes, plodding or doddering.  Enduring; repetitive.
<p>
<b>Uranus:</b> startling, spastic, hyper, often unpredictable, shocking, always changing, hard to tell what's going to happen next, not terribly emotional. Weird, techno, unbelievably brilliant and complicated as well as sometimes ultra-fast; sometimes an incredible, invigorating sense of vitality and liveliness; not very emotionally moving; weird and alien-seeming.
<p>
<b>Neptune:</b> sublime, mysterious, ambient, unfocused, atmospheric; mystical, lots of sounds just kind of melting together, indistinct; really affecting, emotionally; might put a damper on the the tight control and distinctness of the notes you might expect of Saturn- and Mercury-labeled music; on the speed of Uranus-labeled music, on the lack of emotion of Mercury- or Uranus-labeled music, on the determination and energeticness of Mars-labeled music, on the intensity of Pluto-labeled music, etc.  Subtle, hypnotic, entrancing.
<p>
<b>Pluto:</b> intense; scary, terrifying, ominous, truly disturbing, or maybe just with a vague undercurrent of disturbing-ness if drowned out by qualities associated with other labels; profound, rich. Intensifies whatever it's with; thus, a song with Jupiter and Pluto labels might just be intensely, almost scarily, optimistic and happy (and probably really loud).
<p>
<b>Eris:</b> discordant, things sounding a little (or a lot) off, mistimed or off-key, might contain some truly unmusical noises which are painful to listen to, might contain some annoying pointless stuff which deliberately or unintentionally disrupts the song and makes it harder to enjoy, like parts which pointlessly or annoyingly clash with the overall atmosphere of the song.  Perhaps some obnoxious or blaring stuff which you might or might not think the song would be better off without.
<p>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Or, maybe just Eris-like in terms of the content or theme of the song rather than the technical execution of it, like a song which deliberately tries to offend people (but doesn't have any painful musical discord), or contains elements which just don't seem to go together (like a sweet, cheery song which contains an unpleasant reminder of some kind in the lyrics).<p>

&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Despite how bad the foregoing might sound, though, the Eris label, at least in this list, usually doesn't signify anything all that bad, and might just signify an obnoxious, obtrusive element which isn't really all that bothersome, or something which is truly artistic and genuinely contributes to the originality in spite of/because of the discord, weird timing, or whatever - because any truly abhorrent music wouldn't be on this list to begin with.
<p>
<br>
And for some briefer summaries:
<p>
<a name=\"summaries\"></a>
<table border><tr><th>Mercury:<td>clever, fast, intricate, orderly, lots of jibs, jabs, bleeps and boops, but not too irregular and unpredictable, playful, lots of string-plucking and key-pressing, not very emotional, informal
<tr><th>Venus:<td>soft, smooth, sweet, pretty, relaxed, pleasant, bowed strings, harp
<tr><th>Mars:<td> energetic, determined, forceful, rhythmic, loud, harsh, grating, electric guitar, loud drums
<tr><th>Jupiter:<td>happy, cheerful, exuberant, loud, grand, bright, free
<tr><th>Saturn:<td>rhythmic, steady, like clockwork, slow, deep, dark, stately, sober, dignified, sometimes restrained and/or plodding
<tr><th>Uranus:<td>spastic, startling, unexpected, weird, alien, irregular, fast, energetic, unbelievably complex and brilliant, not very emotional
<tr><th>Neptune:<td>arhythmic, drifting, soft, slow, subtle, mysterious, emotional, deeply moving, incredibly atmospheric, otherworldly, amorphous and indistinct, hypnotic, entrancing
<tr><th>Pluto:<td>intense, scary, unsettling, disturbing, extremely dark, deep, rich, profound
<tr><th>Eris:<td>some elements which are discordant, mistimed or off-key, obnoxious or blaring, deliberately or unintentionally annoying, or clashing with the rest of the song.</table>
<p>
Anyhow, I think this is a pretty nice system, especially if you have such a large music collection you can't even remember what everything you have sounds like, let alone find it when you feel like listening to it.
<p>
The red warning labels are mostly pretty self-explanatory, but I would like to point out that I reserve the <span class=\"w\">Disturbing</span> label for songs which I find especially disturbing.  I don't use that label for just any creepy song - only ones which have things like screaming or other scary mayhem which I really don't like to listen to.
<p>
So, be aware that even some of the songs <i>not</i> labeled disturbing might still in fact be quite disturbing (though hopefully to a lesser extent than the ones labeled disturbing), depending on how sensitive you are.  They'll probably have a Pluto label or sublabel.
<p>
<br>

<a name=\"list\">";

	return $res;
}

?>