<?php

include ("vglib.php");

CheckCookie();

session_start();

$spelling_id=$_POST[spelling_id];	//If the previous page was an
	//Edit page, editing an existing name, then, the ID will be 
	//here (delivered by a hidden field on the last page).

function GoBackToForm()
{	global $spelling_id;

	if ($spelling_id) 
	{
		header("Location: editnameform.php?id=$_POST[spelling_id]");
		exit;
	}
	header("Location: editnameform.php");
	exit;
}

	//This is just so we can write what was done in the title
	//of the page:

if ($spelling_id==0)
{	$action="Add";
}
else
{	$action="Edit";
}

//These make it so the forms can be conveniently filled out
//with the user's previous input, such as if the user is sent back
//to the previous page.

$_SESSION[nametype]=$_POST[nametype];
$_SESSION[name]=$_POST[name];
$_SESSION[abbrev]=$_POST[abbrev];
$_SESSION[entity_id]=$_POST[entity_id];
$_SESSION[namecomment]=$_POST[namecomment];
$_SESSION[namecat]=$_POST[namecat];
$_SESSION[same_as_name]=$_POST[same_as_name];


  //Now, we check for required fields from the form.  If any aren't there,
    //then, we send the user back to the forms page and show a
    //helpful error message, along with the forms being 
    //conveniently filled out with the user's previous input.

//The only really required field is the name field - all else is optional.
//Another problem we check for is whether the entity id is a number.

if	(	(!$_POST[name])
		||
		(
			!(	is_numeric ($_POST[entity_id])
			 )
			&& 
			$_POST[entity_id]!=''
		)
	)

{
	if (! is_numeric ($_POST[entity_id] ) && $_POST[name] )
	{
		$_SESSION[error]="entity id must be num";	
	}
	else
	{
		$_SESSION[error]="blank forms";
	}

	GoBackToForm();
}

	//If all is well and we haven't hit an error, then,
	//we connect to the database.

$handle=ConnectToDb();

array_walk($_POST,'CleanInput');  
	//Puts \ behind the quotes and stuff like that to make the
	//input safe for the MySQL DB.


//Just resetting this in case the original, uncleaned input wasn't safe:

$spelling_id=$_POST['spelling_id']; 
$entity_id=$_POST['entity_id'];
$same_as_name = $_POST[same_as_name];
$nametype = $_POST[nametype];


//First, we check to make sure the name and abbreviation don't equal an existing 
//abbreviation, since the abbreviations are all supposed to be unique.

$name = $_POST[name];
$abbrev = $_POST[abbrev];
$permittingdups = $_POST[permitdups];


$query_to_issue="SELECT name, abbrev, spelling_id from vgNames WHERE abbrev = '$name'";

if ($abbrev)
{	$query_to_issue .= "OR abbrev = '$abbrev' OR name = '$abbrev'";
}

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());


if (mysql_num_rows($query_result) > 0)
{	
	if ($spelling_id)
	{
		$existingid=mysql_result($query_result,0,'spelling_id');
		if ($spelling_id!=$existingid)
		{	$_SESSION[error] = "already exists as abbrev";
			GoBackToForm();
		}
	}
	else
	{
		$_SESSION[error] = "already exists as abbrev";
		GoBackToForm();
	}
}


//Then, if the Permit Duplicate Names box isn't checked, we check to make sure the name itself is unique.  We don't want to add any duplicates without making sure it's what the user really wants.

if (!$permittingdups)
{	$query_to_issue="SELECT name from vgNames WHERE name = '$name'";
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

	if (mysql_num_rows($query_result) > 0)
	{
		$_SESSION[error] = "name exists";
		GoBackToForm();
	}
}

if (!$entity_id && !$same_as_name)

	//If the user supplied no entity id or name who this is the same
	//person as, or if either is not there, and we're not editing an 
	//existing name (as evidenced by the spelling_id existing), 
	//then, we figure out what the highest existing entity id is, and 
	//do our own little autoincrement (since MySQL, annoyingly, doesn't 
	//let you have more than one autoincrement field per table).

{
	if (!$spelling_id)	//Meaning the last form wasn't editing an
					//existing name, but is adding a new name.

	{
		$query_to_issue2 = "SELECT MAX(entity_id) FROM vgNames";
		$query_result=mysql_query($query_to_issue2,$handle) or die(mysql_error());

		$res=mysql_result($query_result, 0);
		$entity_id=$res+1;

		//We get the highest existing entity ID and increment it by 1.
		//This is the entity_id the newly added name will have.
	}
}

if ($same_as_name || $_POST[entity_id] )
{

	if ($same_as_name)
	{
		$query_to_issue2 = "SELECT entity_id, nametype FROM vgNames WHERE name = '$same_as_name' OR abbrev = '$same_as_name'";
	}
	else if ($entity_id)
	{
		$query_to_issue2 = "SELECT entity_id, nametype FROM vgNames WHERE entity_id = '$entity_id'";
	}

//If the user supplied a person in the "Same Person As" field, or
//an entity ID (we have to check the POST variable because we
//overwrote the entity_id variable), then, we issue a DB query to
//check to see if that name exists already in the database as a
//name of the same type of the current name.

	$query_result=mysql_query($query_to_issue2,$handle) or die(mysql_error());

	if (mysql_num_rows($query_result) < 1)
	{

//If no name exists, then, we send the user back to the form and give them a 
//helpful error message.

		if ($same_as_name)
		{
			$_SESSION[error]="same entity nonexistent";
			GoBackToForm();
		}
		else
		{

//If the person entered an entity_id, but no name for that ID exists, we
//don't necessarily bounce the user back to the form.  First,
//we check to make sure it isn't higher than any existing 
//entity ID.  If it is, we send the user back to the form 
//and give them a helpful error message.  Otherwise, we use
//the ID.

			$query_to_issue2 = "SELECT MAX(entity_id) FROM vgNames";
			$query_result=mysql_query($query_to_issue2,$handle) or die(mysql_error());
			$res=mysql_result($query_result, 0);
			if ($entity_id>$res)
			{	$_SESSION[error]="supply lower entity id";
				GoBackToForm();
			}
		}
	}
	else 

	//If the first query did yield some results, then, we check out
	//the name type of the first row.  All names with the same
	//entity ID have to be of the same type - no mixing of Musicians,
	//Groups and Sources.  If the name found doesn't have the same type,
	//we send the user back with an error - otherwise, we proceed
	//with the entity ID entered or found.

	{	$resnametype=mysql_result($query_result, 0, 'nametype');

		if ($resnametype!=$nametype)
		{	$_SESSION[error]="name not same type";
			GoBackToForm();
		}
		$entity_id=mysql_result($query_result,0,'entity_id');
	}
}



//OK, now we can start constructing the main query,
//since now we have everything we need to deposit the name
//into the vgNames table.

if (!$spelling_id)	
	//If there's no spelling ID, we're not editing an 
	//existing name, but instead adding a new one, and
	//so we want to insert a new record.

{	$query_to_issue="INSERT";
}
else	
	//If there is a spelling ID, that means we're editing
	//an existing name, so we want to replace the previous record.

{	$query_to_issue="REPLACE";
}


//Now we just need to add the rest of the details in.  Happily
//for us, the INSERT and REPLACE MySQL commands have pretty
//much the same syntax, so the following string is the same
//for both commands.

$namecomment = $_POST[namecomment];
$namecat = $_POST[namecat];

$query_to_issue .= " INTO vgNames (spelling_id, name, abbrev, entity_id, nametype, namecat, namecomment) VALUES ('$spelling_id', '$name', '$abbrev', '$entity_id', '$nametype', '$namecat', '$namecomment')";


//Then we issue it.
mysql_query($query_to_issue,$handle) or die(mysql_error());


//And grab the ID of what was added.  This works correctly for
//REPLACEs as well as INSERTs, by the way.
$addedspelling_id = mysql_insert_id();


//Lastly, if the user was editing an existing entry instead of
//creating a new one, then, we want to update the entity id
//everywhere else it's used.

//Yeah, I guess the whole point of database "normalization" 
//is supposed to be so you can avoid doing stuff like this.
//But... I really don't feel like going to the effort of
//changing it just so it does things the "right" way... this
//works fine.

if ( $spelling_id && ( $_POST[entity_id] || $same_as_name) )
{	
	$query_to_issue = "
		UPDATE vgNameURLs
		SET vgNameURLs.entity_id = '$entity_id'
		WHERE vgNameURLs.spelling_id = '$addedspelling_id'
		";

	mysql_query($query_to_issue,$handle) or die(mysql_error());

	$query_to_issue = "
	
	UPDATE vgRolesAndSongs
	SET vgRolesAndSongs.entity_id = '$entity_id'
	WHERE vgRolesAndSongs.spelling_id = '$addedspelling_id'
	";

	mysql_query($query_to_issue,$handle) or die(mysql_error());

};


//Now, finally, we output the web page itself to show the results.

echo "<html><head><title>$nametype $addedspelling_id $action";

echo "ed</title>
<link rel=stylesheet href='css/a.css' type='text/css'>
</head>

<body><center>";

ListNav();

echo "<h1>$nametype $addedspelling_id $action";

echo "ed</h1>
<p>
<br>
<b>Name:</b> $name<br>
<b>Abbreviation:</b> $abbrev
<p>
<b>Entity ID:</b> $entity_id<br>
<b>Type:</b> $nametype<br>
<b>Comment:</b> $namecomment<br>
<b>Category:</b> $namecat";

exit;

?>