<?php

include ("vglib.php");

CheckCookie();

include ("vglinklib.php");
include ("lib-editsong.php");

session_start();

$song_id=$_POST[song_id];	//If the previous page was an
	//Edit page, then, the ID will be here (delivered by a hidden
	//field on the last page).


	//This is just so we can write what was done in the title
	//of the page:

if ($song_id==0)
{	$action="Add";
}
else
{	$action="Edit";
}

//These make it so the forms will be conveniently filled out
//with the user's previous input whenever the page is
//reloaded.

$_SESSION[title]=$_POST[title];
$_SESSION[sources]=$_POST[sources];
$_SESSION[performers]=$_POST[performers];
$_SESSION[vocalists]=$_POST[vocalists];
$_SESSION[remixers]=$_POST[remixers];
$_SESSION[composers]=$_POST[composers];
$_SESSION[spellingids]=$_POST[spellingids];
$_SESSION[hours]=$_POST[hours];
$_SESSION[mins]=$_POST[mins];
$_SESSION[secs]=$_POST[secs];
$_SESSION[label1]=$_POST[label1];
$_SESSION[label2]=$_POST[label2];
$_SESSION[label3]=$_POST[label3];
$_SESSION[sublabels]=$_POST[sublabels];
$_SESSION[genre]=$_POST[genre];
$_SESSION[filename]=$_POST[filename];
$_SESSION[localfolder]=$_POST[localfolder];
$_SESSION[url]=$_POST[url];
$_SESSION[urltype]=$_POST[urltype];
$_SESSION[comment]=$_POST[comment];
$_SESSION[warning]=$_POST[warning];
$_SESSION[prevsources]=$_POST[prevsources];
$_SESSION[prevperformers]=$_POST[prevperformers];
$_SESSION[prevvocalists]=$_POST[prevvocalists];
$_SESSION[prevremixers]=$_POST[prevremixers];
$_SESSION[prevcomposers]=$_POST[prevcomposers];
$_SESSION[vocals]=$_POST[vocals];
$_SESSION[words]=$_POST[words];
$_SESSION[malevocals]=$_POST[malevocals];
$_SESSION[femvocals]=$_POST[femvocals];
$_SESSION[foreignlang]=$_POST[foreignlang];
$_SESSION[profanity]=$_POST[profanity];
$_SESSION[volumewarning]=$_POST[volumewarning];
$_SESSION[grating]=$_POST[grating];
$_SESSION[disturbing]=$_POST[disturbing];
$_SESSION[humorous]=$_POST[humorous];
$_SESSION[whenadded]=$_POST[whenadded];


//OK, now we grab the planet checkboxes.

$planetboxes=$_POST['planets'];

	//And then... uhhh... I don't remember what this was for, but
	//I think it's definitely of use for something.

if (is_array($planetboxes))
{	
	$x=0;
	foreach ($planetboxes as $pla)
	{	$plakeys[$x]=$pla;
		$x++;
	}
	$plarray = array_fill_keys($plakeys,'present');
}


//And then we grab the planet ratings.

$me=$_POST['me'];
$ve=$_POST['ve'];
$ma=$_POST['ma'];
$ju=$_POST['ju'];
$sa=$_POST['sa'];
$ur=$_POST['ur'];
$ne=$_POST['ne'];
$pl=$_POST['pl'];
$er=$_POST['er'];

	//And make an array out of them.

$plaratings=array(0,$me,$ve,$ma,$ju,$sa,$ur,$ne,$pl,$er);


	//Uh, I forgot what this is for too.  I guess I should
	//write comments when I'm actually writing the code and
	//have a clearer idea of what the heck I'm doing.

array_walk($plaratings,uppercase);


//OK, now this zips through the ratings and checkboxes and
//prepares the ratings' values for input into the database.
//
//If a rating is X (which means, definitely not presentt), 
//its equivalent in the database will be -9.
//
//If a rating is blank but that planet's checkbox is checked,
//its equivalent in the database will be not 0, but -8.
//
//Any ratings greater than 4 will be changed to 4.  Any
//ratings less than 0 and not less than -7 will be made
//positive, and if they turn out to be greater than 4,
//they will be changed to 4.

for ($x=1;$x<10;$x++)
{	$checkbox = $plarray[$x];
	$rating=$plaratings[$x];

	if ($checkbox=='')
	{	if ($rating=="X")
		{	$rating=-9;
		}
		else
		{	$rating=0;
		}
	}
	else if ($checkbox)
	{	if ($rating=="X")
		{	$rating=-9;
		}
		else if ($rating=="0" || $rating=='')
		{	$rating=-8;
		}

		if ( ($rating < 0) && !($rating<-7) )
		{	$rating=abs($rating);			
		}
		if ($rating>4)
		{
			$rating = 4;
		}
	}
	$plaratings[$x]=$rating;
}

$_SESSION[planets]=$plaratings;


  //Check for required fields from the form.  If any aren't there,
    //then, we send the user back to the forms page and show a
    //helpful error message, along with the forms being 
    //conveniently filled out with the user's previous input.

/* Originally, more forms were required than just the title and source, but I
changed my mind.  if ( (!$_POST[title]) || (!$_POST[sources]) || ( (!$_POST[label1]) && (!$_POST[label2]) && (!$_POST[label3]) ) ) */

if ( (!$_POST[title]) || (!$_POST[sources]) )
{
	$_SESSION[error]="blank forms";
	GoBackToForm();
}

	//If all is well and we haven't hit an error, then, 
	//we can connect to the database.

$handle=ConnectToDb();

$rawlocalfolder=$_POST[localfolder];
$rawfilename=$_POST[filename];

array_walk($_POST,'CleanInput');  
	//Puts \ behind the quotes and stuff like that to make the
	//input safe for the MySQL DB.


//Just resetting this in case the original, uncleaned input wasn't safe:
$song_id=$_POST['song_id'];
$me=$_POST['me'];
$ve=$_POST['ve'];
$ma=$_POST['ma'];
$ju=$_POST['ju'];
$sa=$_POST['sa'];
$ur=$_POST['ur'];
$ne=$_POST['ne'];
$pl=$_POST['pl'];
$er=$_POST['er'];


//OK, now we need to retrieve some stuff from the database, based
//on the user's input.  Namely, we have to get the entity ids
//and spelling ids for the names the user input.


$types = array("source", "performer", "vocalist", "remixer", "composer");

$num_of_types=count($types);


	//We begin constructing a query.

$query_to_issue="SELECT name, abbrev, entity_id, spelling_id FROM vgNames WHERE name in (";



$allnames=array();


//Oh no, it's time for some "variable variables".

$x=0;

while ($x<$num_of_types)
{	$typename=$types[$x] . "s";
	$list_of_namevars[$x]=$typename;

	${$typename}=$_POST[$typename];

	$arraytypename="array" . $typename;

	$list_of_namearrays[$x]=$arraytypename;

	${$arraytypename} = MakeStringIntoArray( ${$typename}, 1);

	${$arraytypename} = array_values( ${$arraytypename} );

	$allnames = array_merge($allnames, ${$arraytypename});

	$formattypename="formatted" . $typename;
	$list_of_formatnamearrays[$x]=$formattypename;

	${$formattypename} = MakeArrayIntoFormattedNameString( ${$arraytypename}, 1);

	if (${$formattypename})
	{	$query_to_issue .= ${$formattypename} . ", ";
	}
	$x++;
}

$query_to_issue=rtrim($query_to_issue, ", ");
$query_to_issue .= ") OR abbrev in (";
$x=0;

while ($x<$num_of_types)
{	$typename=$types[$x] . "s";
	$formattypename="formatted" . $typename;
	if (${$formattypename})
	{
		$query_to_issue .= ${$formattypename} . ", ";
	}
	$x++;
}

$query_to_issue=rtrim($query_to_issue, ", ");

$query_to_issue .= ")";

$allnames=array_iunique($allnames);
$allnames=array_values($allnames);

$num_of_allnames=count($allnames);


	//Finally, we get to issue the query.

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


	//If there are fewer rows than there are entries in the array,
	//that means there are some entries in the array which aren't
	//yet in the database.  So, we send the user back to the form
	//with an error.

if (mysql_num_rows($query_result) < $num_of_allnames)
{
	$_SESSION[error]="nonexistent name";
	GoBackToForm();
}


while ( $row = mysql_fetch_array($query_result) )
{	$name=strtolower($row[name]);
	$name=mysql_real_escape_string($name);

	$abbrev=strtolower($row[abbrev]);
	$abbrev=mysql_real_escape_string($abbrev);

	$spellingid=$row[spelling_id];
	$entityid=$row[entity_id];

	$array_namespellingids[$name]=array($spellingid, $entityid);
	$array_namespellingids[$abbrev]=array($spellingid, $entityid);
}


//OK, now with all that out of the way, we move on to 
//translating the labels into their numerical equivalents.


$label1=$_POST['label1'];
$label2=$_POST['label2'];
$label3=$_POST['label3'];

$label1 = PlaToNum( strtolower($label1) );
$label2 = PlaToNum( strtolower($label2) );
$label3 = PlaToNum( strtolower($label3) );


//Whew, that wasn't too hard.  OK, now we make sure the file path URL
//is ready.

$fixedlocalfolder=BackToForwardSlashes($rawlocalfolder);
$fixedlocalfolder=ConvertFirefoxFormat($fixedlocalfolder);
$fixedlocalfolder=ConvertSpacesTo20($fixedlocalfolder);
$completelocalurl=$fixedlocalfolder . "/" . $rawfilename;

$pathparts=pathinfo($completelocalurl);

$filetype=$pathparts['extension'];

$makeplainpath=explode("file://localhost/",$completelocalurl);

$thisphppath = $makeplainpath[1];
$thisphppath = Convert20ToSpaces($thisphppath);

if (is_file($thisphppath) )
{	//echo "IT'S A FILE!!!";
	$filesize=filesize($thisphppath);
}


//Now we have everything we need to deposit the song
//into the vgSongDetails table.

if (!$song_id)
	//If there's no ID, we're not editing an 
	//existing song, but instead adding a new one, and
	//so we want to insert a new record.

{	$query_to_issue="INSERT";
}
else	
	//If there is an ID, that means we're editing
	//an existing song, so we want to replace the previous record.

{	$query_to_issue="REPLACE";
	$whenadded = $_POST[whenadded];
}


//Now we just need to add the rest of the details in.  Happily
//for us, the INSERT and REPLACE MySQL commands have pretty
//much the same syntax, so the following string is the same
//for both commands.

$title = $_POST[title];
$filename = $_POST[filename];
$url = $_POST[url];
$urltype = $_POST[urltype];
$sublabels = $_POST[sublabels];
$genre = $_POST[genre];
$comment = $_POST[comment];
$warning = $_POST[warning];
$vocals=$_POST[vocals];
$words=$_POST[words];
$malevocals=$_POST[malevocals];
$femvocals=$_POST[femvocals];
$foreignlang=$_POST[foreignlang];
$profanity=$_POST[profanity];
$volumewarning=$_POST[volumewarning];
$grating=$_POST[grating];
$disturbing=$_POST[disturbing];
$humorous=$_POST[humorous];
$hours=$_POST[hours];
$mins=$_POST[mins];
$secs=$_POST[secs];

if ($hours>255)
{	$hours=255;
}
if ($mins>59)
{	$mins=59;
}
if ($secs>59)
{	$secs=59;
}

$query_to_issue .= " INTO vgSongDetails (song_id, title, filename, localfolder, filesize, filetype, hours, mins, secs, url, urltype, label1, label2, label3, sublabels, genre, warning, comment, vocals, words, malevocals, femvocals, foreignlang, profanity, volumewarning, grating, disturbing, humorous, ";

if ($song_id)
{	$query_to_issue .= "whenadded, ";
}

$query_to_issue .= "whenmodified, me, ve, ma, ju, sa, ur, ne, pl, er)

VALUES ('$song_id', '$title', '$filename', '$fixedlocalfolder', '$filesize', '$filetype', '$hours', '$mins', '$secs', '$url', '$urltype', '$label1', '$label2', '$label3', '$sublabels', '$genre', '$warning', '$comment', '$vocals', '$words', '$malevocals', '$femvocals', '$foreignlang', '$profanity', '$volumewarning', '$grating', '$disturbing', '$humorous', ";

if ($song_id)
{	$query_to_issue .= "'$whenadded', ";
}

$query_to_issue .= "now()";


//Then we add the planet ratings to the query we're constructing.

$x=1;

while ($x<=9)
{	$query_to_issue .= ", '$plaratings[$x]'";
	$x++;
}

$query_to_issue .= ")";


//Then we issue the query.
mysql_query($query_to_issue,$handle) or die(mysql_error());


//And grab the ID of what was added.  This works correctly for
//REPLACEs as well as INSERTs, by the way.
$addedsong_id = mysql_insert_id();


//Now, if we're editing an existing song, we wipe out some previous 
//name associations with this song so we can add them anew.  We
//try to only wipe out name associations that have changed.

$x=0;

$query_to_issue = "INSERT INTO vgRolesAndSongs (spelling_id, entity_id, song_id, role) VALUES ";

if ($song_id)
{
	$delete_query_to_issue = "DELETE FROM VgRolesAndSongs WHERE (song_id = '$addedsong_id' AND (";

	while ($x<$num_of_types)
	{	$rolename=$types[$x];
		$typename=$types[$x] . "s";
		$prevtypename = "prev" . $typename;
		${$prevtypename} = $_POST[$prevtypename];

		if ( ${$typename} != ${$prevtypename})
		{	$issuedeletequery="yes";
			$arraytypename = "array" . $typename;
			$arrayprevtypename = "array" . $prevtypename;
			${$arrayprevtypename} = MakeStringIntoArray( ${$prevtypename}, 1);
			${$arrayprevtypename} = array_values( ${$arrayprevtypename} );
			$delete_query_to_issue .= " role='$rolename' OR ";

			$num_of_names_of_this_type = count( ${$arraytypename} );
			if ($num_of_names_of_this_type)
			{	$y=0;
				$issuemainquery="yes";
				while ($y<$num_of_names_of_this_type)
				{	$thisname=strtolower( ${$arraytypename}[$y] );
					$thisspellingid = $array_namespellingids[$thisname][0];
					$thisentityid = $array_namespellingids[$thisname][1];

					$query_to_issue .= "('$thisspellingid', '$thisentityid', '$addedsong_id', '$rolename'), ";
					$y++;
				}
			}
			else if (!$num_of_names_of_this_type)
			{	$issuemainquery="no";
			}

		};
		$x++;
	}	
	if ($issuedeletequery=="yes")
	{
			$delete_query_to_issue = substr($delete_query_to_issue, 0, -4);
			$delete_query_to_issue .= ") )";
			//echo "Delete query: $delete_query_to_issue<p>";
			mysql_query($delete_query_to_issue,$handle) or die(mysql_error());
	}
	if ($issuemainquery=="yes")
	{
		$query_to_issue=substr($query_to_issue, 0, -2);
	//	echo "Main query: $query_to_issue<p>";
		mysql_query($query_to_issue,$handle) or die(mysql_error());
	}

}
else	//if we're just adding a new song...
{
	$x=0;
	while ($x<$num_of_types)
	{	$rolename=$types[$x];
		$typename=$types[$x] . "s";

		$arraytypename = "array" . $typename;
		$num_of_names_of_this_type = count( ${$arraytypename} );
	
		$lowercasearray=${$arraytypename};

		array_walk($lowercasearray, 'lowercase');

		if ($num_of_names_of_this_type)
		{	$y=0;
			while ($y<$num_of_names_of_this_type)
			{	$thisname=strtolower( ${$arraytypename}[$y] );
				$thisspellingid = $array_namespellingids[$thisname][0];
				$thisentityid = $array_namespellingids[$thisname][1];

				$query_to_issue .= "('$thisspellingid', '$thisentityid', '$addedsong_id', '$rolename'), ";
				$y++;
			}
		}	
		$x++;
	}
	$query_to_issue=substr ($query_to_issue, 0, -2);
	mysql_query($query_to_issue,$handle) or die(mysql_error());
}

  
//order by generic_id in order to make roles names come up in the order they were originally entered.


echo "<html><head><title>Song $addedsong_id $action";

echo "ed</title>
<link rel=stylesheet href='css/a.css' type='text/css'>
</head>
<body><center>";

ListNav();

echo "<h1>Song $addedsong_id $action"; echo "ed</h1>
<p>
<big><a href='listsongs.php'>Song List</a></big>
<p>
<b>Title:</b> $title<br>
<b>Sources:</b> $sources<br>
<b>Performers:</b> $performers<br>
<b>Vocalists:</b> $vocalists<br>
<b>Remixers:</b> $remixers<br>
<b>Original Composers:</b> $composers<br>
<b>File name:</b> $rawfilename<br>
<b>Local folder:</b> $fixedlocalfolder<br>
<b>File size:</b> $filesize<br>
<b>URL:</b> $url<br>
<b>URL Type:</b> $urltype<br>
<b>Labels:</b> $label1 - $label2 - $label3<br>
<b>Sublabels:</b> $sublabels<br>
<b>Comment:</b> $comment<br>
<b>Warning:</b> $warning<br>
<b>Genre:</b> $genre";

exit;

?>